<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<title>zh-tw/HowTos/CommunityBuildSystem</title>
<link rel="stylesheet" type="text/css" media="all" charset="utf-8" href="modern/css/common.css">
<link rel="stylesheet" type="text/css" media="screen" charset="utf-8" href="modern/css/screen.css">
<link rel="stylesheet" type="text/css" media="print" charset="utf-8" href="modern/css/print.css">
<style type="text/css">
ul.pagetitle{
  display: inline;
  margin: 0;
  padding: 0;
  font-size: 1.5em;
}
li.pagetitle{
  display: inline;
  margin: 0;
}
td.noborder {
  border: 0;
}
</style>
</head>
<body>
<table>
<tr>
<td class="noborder">
<img src="logo.png">
</td>
<td class="noborder">
<ul class="pagetitle">
<li class="pagetitle"><a class="backlink">zh-tw/HowTos/CommunityBuildSystem</a>
</ul>
<br><br>
[<a href="FrontPage.html">FrontPage</a>]&nbsp;[<a href="TitleIndex.html">TitleIndex</a>]&nbsp;[<a href="WordIndex.html">WordIndex</a>]&nbsp;
</td>
</tr>
</table>
<hr>
<div id="page"><h1 style="background-color:Red; color:White">This is a read-only <a href="https://gitlab.com/CentOS/docs/wiki_archives">archived version</a> of wiki.centos.org</h1>
<div dir="ltr" id="content" lang="zh-tw"><span class="anchor" id="top"></span>
<span class="anchor" id="line-1"></span><span class="anchor" id="line-2"></span><span class="anchor" id="line-3"></span><p class="line867"><div class="table-of-contents"><p class="table-of-contents-heading">Contents<ol><li>
<a href="#A.2BijtRik4AUAteM2I2-">註冊一個帳戶</a></li><li>
<a href="#A.2BU9Zfl1NUUqk-">取得協助</a></li><li>
<a href="#A.2BgehmQl76ii0-">臨時建設</a></li><li>
<a href="#A.2Bahlull76ii0-">標準建設</a></li><li>
<a href="#A.2BXAdz.2FmcJdoRe.2BootUqCQMk4AUAtqGXxkUWc-">將現有的建設加進一個標籤內</a></li><li>
<a href="#Git_.2BXvqKLQ-">Git 建設</a></li><li>
<a href="#A.2BWVdO9l3yc3Je.2BnrL-">套件已獲建立</a></li><li>
<a href="#A.2BXfKQTmcfYZGLSQ-">已過期憑證</a></li><li>
<a href="#A.2BY6F1KF3ykE5mQnaE_SSLv3">採用已過時的 SSLv3</a></li><li>
<a href="#A.2BYcl1KFkaUAs_koji_.2BW.2BZPiw-">應用多個 koji 實例</a></li></ol></li></ol></div> <span class="anchor" id="line-4"></span><span class="anchor" id="line-5"></span><p class="line867">
<h1 id="A.2BeT5.2FpF76ii18.2B31x-">社群建設系統</h1>
<span class="anchor" id="line-6"></span><span class="anchor" id="line-7"></span><p class="line867"><a class="http" href="http://cbs.centos.org/">CBS</a> 是供<a href="./zh(2d)tw(2f)SpecialInterestGroup.html">特別興趣小組</a>成員用的社群建設系統。 <span class="anchor" id="line-8"></span><span class="anchor" id="line-9"></span><p class="line867">
<h1 id="A.2BX.2BuQH1FllYA-">快速入門</h1>
<span class="anchor" id="line-10"></span><span class="anchor" id="line-11"></span><p class="line867">
<h2 id="A.2BijtRik4AUAteM2I2-">1. 註冊一個帳戶</h2>
<span class="anchor" id="line-12"></span><ol type="1"><li><p class="line862">拜訪 <a class="https" href="https://accounts.centos.org">帳戶系統</a> <span class="anchor" id="line-13"></span></li><li>選擇「New Account」 <span class="anchor" id="line-14"></span></li><li>在表格內填上你的資料 <span class="anchor" id="line-15"></span></li><li>申請成為你想參予的 SIG 的會員 <span class="anchor" id="line-16"></span><ul><li><p class="line862">在每個星期一的 <a class="https" href="https://www.centos.org/community/calendar#community-buildsystem-infrastructure-meeting">CBS 會議</a>開始之前，管理員將會與 SIG 的成員處理會員的申請 <span class="anchor" id="line-17"></span></li></ul></li><li><p class="line862">獲批准後，你須要安裝客端工具並建立自己的 SSL 憑證，詳情見 <a href="./zh(2d)tw(2f)HowTos(2f)CentosPackager.html">zh-tw/HowTos/CentosPackager</a> <span class="anchor" id="line-18"></span></li><li><p class="line862">執行 <tt>cbs&nbsp;moshimoshi</tt>，你應該在輸出看見自己的用戶名稱。 <span class="anchor" id="line-19"></span></li><li><p class="line891"><strong>意外收獲</strong>：<a class="https" href="https://github.com/rnc/brew-koji">Github</a> 為 zsh 及 bash 用戶提供（非官方的）自動填充功能（請留意 bash 的填充功能已獲更新，zsh 的較舊。明白嗎？） <span class="anchor" id="line-20"></span><span class="anchor" id="line-21"></span></li></ol><p class="line867">
<h2 id="A.2BU9Zfl1NUUqk-">2. 取得協助</h2>
<span class="anchor" id="line-22"></span><p class="line874">如果你有 CBS 上的困難，你有數個取得協助的途徑： <span class="anchor" id="line-23"></span><ul><li>在 freenode 的 IRC 網絡加入 #centos-devel <span class="anchor" id="line-24"></span></li><li><p class="line862">在 <a class="mailto" href="mailto:centos-devel@centos.org">centos-devel@centos.org</a> 郵件列表發出一則信息 <span class="anchor" id="line-25"></span></li><li><p class="line862">在 <a class="https" href="https://bugs.centos.org">https://bugs.centos.org</a> 建立錯誤報告（項目：Buildsys，類別：community buildsys） <span class="anchor" id="line-26"></span><span class="anchor" id="line-27"></span></li></ul><p class="line867">
<h1 id="RPM_.2BUh1z7Q-">RPM 初班</h1>
<span class="anchor" id="line-28"></span><ul><li>RPM 術語的快速回顧： <span class="anchor" id="line-29"></span><span class="anchor" id="line-30"></span></li></ul><p class="line874">{{{SRPM=ksh-20120801-10.el6.4.src.rpm <span class="anchor" id="line-31"></span>NAME=ksh <span class="anchor" id="line-32"></span>VERSION=20120801 <span class="anchor" id="line-33"></span>RELEASE=10.el6.4 <span class="anchor" id="line-34"></span>DISTTAG=el6 <span class="anchor" id="line-35"></span>}}} <span class="anchor" id="line-36"></span><span class="anchor" id="line-37"></span><p class="line867">
<h1 id="Koji_.2BUh1z7Q-">Koji 初班</h1>
<span class="anchor" id="line-38"></span><span class="anchor" id="line-39"></span><p class="line874">Koji 有數個必須掌握的基本概念： <span class="anchor" id="line-40"></span><ul><li><p class="line862">標籤（tag）：它可以是一個 buildroot 定義標籤（&lt;小組名稱&gt;&lt;主要版本&gt;-&lt;專案&gt;-&lt;專案發行本&gt;-&lt;標籤&gt;-build、storage7-gluster-37-el7-build），或者是一個目標標籤（&lt;小組名稱&gt;&lt;主要版本&gt;-&lt;專案&gt;-&lt;專案發行本&gt;-release 或 &lt;小組名稱&gt;&lt;主要版本&gt;-&lt;專案&gt;-&lt;專案發行本&gt;-testing）。 <span class="anchor" id="line-41"></span><span class="anchor" id="line-42"></span></li><li class="gap">目標（target）：它把一個 buildroot 定義標籤聯繫到一個目標標籤。 <span class="anchor" id="line-43"></span><ul><li style="list-style-type:none">當你建立 srpm 時，該目標便會被應用在指令行。 <span class="anchor" id="line-44"></span><p class="line862">根據預先設定，所有成功建立的套件都會被令名為 &lt;小組名稱&gt;&lt;主要版本&gt;-&lt;專案&gt;-&lt;專案發行本&gt;-testing。 <span class="anchor" id="line-45"></span><span class="anchor" id="line-46"></span><p class="line862">每個目標在 CBS 內都採用 &lt;小組名稱&gt;&lt;主要版本&gt;-&lt;專案&gt;-&lt;專案發行本&gt;-&lt;發行標籤&gt; 這個架構，如：virt6-xen-44-el6 、storage7-gluster-37-el7、storage7-gluster-37-el7.centos、等…… <span class="anchor" id="line-47"></span><span class="anchor" id="line-48"></span></li></ul></li><li class="gap">套件（package）：源碼 rpm 的名稱。例如：ksh-20120801-10.el6.4.src.rpm <span class="anchor" id="line-49"></span><span class="anchor" id="line-50"></span></li><li class="gap">被建立的套件：這泛指 koji 建立的檔案，例如：ksh-20120801-10.el6_5.4.rpm、ksh-20120801-10.el6.4-devel.rpm、等…… <span class="anchor" id="line-51"></span><span class="anchor" id="line-52"></span></li><li class="gap">進行標籤：你可以把建設環境聯繫到不同的目標標籤。譬如在 CBS 的工作流程中，你可以透過標籤把套件從 -testing 提升至 -release。 <span class="anchor" id="line-53"></span><span class="anchor" id="line-54"></span></li></ul><p class="line867">
<h1 id="A.2BUil1KA_CBS_.2BkDKITF76ii0-">利用 CBS 進行建設</h1>
<span class="anchor" id="line-55"></span><span class="anchor" id="line-56"></span><p class="line874">以下文檔假設有一個名為 bananas 的特別興趣小組。請用你的特別興趣小組名稱來取替，但我們已建立了 bananas 標籤作為測試場地，讓你可進行試驗。 <span class="anchor" id="line-57"></span><span class="anchor" id="line-58"></span><p class="line867">
<h2 id="A.2BgehmQl76ii0-">1. 臨時建設</h2>
<span class="anchor" id="line-59"></span><span class="anchor" id="line-60"></span><p class="line874">Koji 提供一個選項讓你可運用任何目標建立臨時的套件。 <span class="anchor" id="line-61"></span><span class="anchor" id="line-62"></span><span class="anchor" id="line-63"></span><pre><span class="anchor" id="line-1"></span>    cbs build --scratch bananas6-el6 ksh-20120801-10.el6.4.src.rpm</pre><span class="anchor" id="line-64"></span><span class="anchor" id="line-65"></span><p class="line867">
<h2 id="A.2Bahlull76ii0-">2. 標準建設</h2>
<span class="anchor" id="line-66"></span><ul><li>建立新套件的第一步，就是為套件加入你所需的目標標籤 <span class="anchor" id="line-67"></span></li></ul><p class="line867"><span class="anchor" id="line-68"></span><span class="anchor" id="line-69"></span><span class="anchor" id="line-70"></span><pre><span class="anchor" id="line-1-1"></span>   cbs add-pkg --owner "username" bananas6-testing ksh
<span class="anchor" id="line-2"></span>   cbs add-pkg --owner "username" bananas6-release ksh</pre><span class="anchor" id="line-71"></span><p class="line874">這個動作必須為每個特別興趣小組的每個套件進行一次。 <span class="anchor" id="line-72"></span><span class="anchor" id="line-73"></span><ul><li>然後你可以開始進行建設： <span class="anchor" id="line-74"></span></li></ul><p class="line867"><span class="anchor" id="line-75"></span><span class="anchor" id="line-76"></span><pre><span class="anchor" id="line-1-2"></span>   cbs build bananas6-el6 ksh-20120801-10.el6.4.src.rpm</pre><span class="anchor" id="line-77"></span><span class="anchor" id="line-78"></span><p class="line867">
<h2 id="A.2BXAdz.2FmcJdoRe.2BootUqCQMk4AUAtqGXxkUWc-">3. 將現有的建設加進一個標籤內</h2>
<span class="anchor" id="line-79"></span><span class="anchor" id="line-80"></span><p class="line874">有時，你想建設一個套件但收到如下的錯誤訊息： <span class="anchor" id="line-81"></span><span class="anchor" id="line-82"></span><span class="anchor" id="line-83"></span><pre><span class="anchor" id="line-1-3"></span>GenericError: Build already exists (id=1231, state=COMPLETE): {'name': '$pkgname'..... lot of details ....}</pre><span class="anchor" id="line-84"></span><span class="anchor" id="line-85"></span><p class="line874">意思就是你已經將套件加進一個目的標籤（利用 cbs add-pkg 指令，見上文），但當你嘗試建設該套件時，koji 已用同一個 NVR 建設它，或許是在另一個標籤下。 <span class="anchor" id="line-86"></span>因此，koji 拒絕建設它，因為 koji 不會重新建設擁有同一 NVR 的套件。 <span class="anchor" id="line-87"></span>簡單的建決方法就是「標籤」該建設，讓它自動出現在你的標籤庫內。 <span class="anchor" id="line-88"></span>假設該套件的名稱是 yaml-cpp，而你已經建設了 yamp-cpp-0.5.1-6.el7（你可利用 koji 的搜尋功能檢查它是由誰建立，及擁有甚麼標籤）。 <span class="anchor" id="line-89"></span><span class="anchor" id="line-90"></span><span class="anchor" id="line-91"></span><pre><span class="anchor" id="line-1-4"></span>cbs tag-build bananas7-testing yaml-cpp-0.5.1-6.el7</pre><span class="anchor" id="line-92"></span><span class="anchor" id="line-93"></span><p class="line874">Kojira 將會重建軟件庫資料，並加入已建設的套件。 <span class="anchor" id="line-94"></span><span class="anchor" id="line-95"></span><p class="line867">
<h2 id="Git_.2BXvqKLQ-">4. Git 建設</h2>
<span class="anchor" id="line-96"></span><span class="anchor" id="line-97"></span><p class="line874">一個簡單的例子： <span class="anchor" id="line-98"></span><span class="anchor" id="line-99"></span><span class="anchor" id="line-100"></span><span class="anchor" id="line-101"></span><span class="anchor" id="line-102"></span><pre><span class="anchor" id="line-1-5"></span> cbs add-pkg --owner "username" bananas7-testing tzdata
<span class="anchor" id="line-2-1"></span> cbs add-pkg --owner "username" bananas7-release tzdata
<span class="anchor" id="line-3"></span> cbs build bananas7-el7 "git+https://git.centos.org/git/rpms/tzdata.git?#e24d98"</pre><span class="anchor" id="line-103"></span><span class="anchor" id="line-104"></span><p class="line867">
<h1 id="A.2BXjiJi5MviqRP4WBv-">常見錯誤信息</h1>
<span class="anchor" id="line-105"></span><span class="anchor" id="line-106"></span><p class="line867">
<h2 id="A.2BWVdO9l3yc3Je.2BnrL-">1. 套件已獲建立</h2>
<span class="anchor" id="line-107"></span><span class="anchor" id="line-108"></span><p class="line867"><span class="anchor" id="line-109"></span><span class="anchor" id="line-110"></span><pre><span class="anchor" id="line-1-6"></span>GenericError: Build already exists</pre><span class="anchor" id="line-111"></span><span class="anchor" id="line-112"></span><p class="line874">見上文有關「將現有的建設加進一個標籤內」的段落。 <span class="anchor" id="line-113"></span><span class="anchor" id="line-114"></span><p class="line867">
<h2 id="A.2BXfKQTmcfYZGLSQ-">2. 已過期憑證</h2>
<span class="anchor" id="line-115"></span><span class="anchor" id="line-116"></span><p class="line874">要是你看見這個錯誤信息： <span class="anchor" id="line-117"></span><span class="anchor" id="line-118"></span><span class="anchor" id="line-119"></span><pre><span class="anchor" id="line-1-7"></span>"Error: [('SSL routines','SSL_shutdown', 'shutdown while in init')]</pre><span class="anchor" id="line-120"></span><p class="line874">有可能你的 ~/.centos.cert x509 憑證已過期。你可以利用以下指令確定： <span class="anchor" id="line-121"></span><span class="anchor" id="line-122"></span><span class="anchor" id="line-123"></span><pre><span class="anchor" id="line-1-8"></span>openssl x509 -in ~/.centos.cert -noout -text|grep "Not After"</pre><span class="anchor" id="line-124"></span><span class="anchor" id="line-125"></span><p class="line862">如果它已過期，你只須（按照 <a class="https" href="https://wiki.centos.org/zh-tw/HowTos/CentosPackager">https://wiki.centos.org/zh-tw/HowTos/CentosPackager</a> 內的第 2 步）利用 centos-cert 建立新的憑證便可以了。 <span class="anchor" id="line-126"></span><span class="anchor" id="line-127"></span><p class="line867">
<h2 id="A.2BY6F1KF3ykE5mQnaE_SSLv3">3. 採用已過時的 SSLv3</h2>
<span class="anchor" id="line-128"></span><span class="anchor" id="line-129"></span><p class="line874">要是你看見這個錯誤信息： <span class="anchor" id="line-130"></span><span class="anchor" id="line-131"></span><span class="anchor" id="line-132"></span><pre><span class="anchor" id="line-1-9"></span>Error: [('SSL routines', 'SSL3_READ_BYTES', 'sslv3 alert handshake failure'), ('SSL routines', 'SSL3_WRITE_BYTES', 'ssl handshake failure')]</pre><span class="anchor" id="line-133"></span><span class="anchor" id="line-134"></span><p class="line862">那麼你需要<a class="http" href="http://lists.centos.org/pipermail/centos-announce/2014-October/020682.html">以手動方式修正</a>你的 koji 實例，以 TLSv1 替代 SSLv3（已證實不安全）。 <span class="anchor" id="line-135"></span><span class="anchor" id="line-136"></span><p class="line867">
<h1 id="A.2BkDKWjootf24-">進階設置</h1>
<span class="anchor" id="line-137"></span><span class="anchor" id="line-138"></span><p class="line867">
<h2 id="A.2BYcl1KFkaUAs_koji_.2BW.2BZPiw-">1. 應用多個 koji 實例</h2>
<span class="anchor" id="line-139"></span><span class="anchor" id="line-140"></span><ul><li><p class="line862">Koji 透過 -p 旗標支援設定檔。我們定義一個名叫 cbs 的設定檔（因此你才能使用這個方便的指令：<tt class="backtick">/usr/bin/cbs</tt>） <span class="anchor" id="line-141"></span><span class="anchor" id="line-142"></span></li><li class="gap">如果要 koji 這個指令採用特定的設定檔，你可執行： <span class="anchor" id="line-143"></span></li></ul><p class="line867"><span class="anchor" id="line-144"></span><pre><span class="anchor" id="line-1-10"></span>   koji -p cbs list-tags</pre><span class="anchor" id="line-145"></span><ul><li>你也可以同時保留 Fedora 及其它 koji 實例的設定。 <span class="anchor" id="line-146"></span></li><li>不應用 -p 時所採用的伺服器應該在 [koji] 部份內指定，因為這是預設設定。 <span class="anchor" id="line-147"></span><span class="anchor" id="line-148"></span></li></ul><p class="line867">
<h1 id="A.2BXfJ35VVPmEw-">已知問題</h1>
<span class="anchor" id="line-149"></span><span class="anchor" id="line-150"></span><ul><li>現時仍未啟用建立 git.c.o 的支援。 <span class="anchor" id="line-151"></span><span class="anchor" id="line-152"></span></li></ul><p class="line867">
<h1 id="A.2BWRaQ6JAjfVA-">外部連結</h1>
<span class="anchor" id="line-153"></span><span class="anchor" id="line-154"></span><p class="line862">官方文檔：<a class="https" href="https://fedoraproject.org/wiki/Koji">https://fedoraproject.org/wiki/Koji</a> <span class="anchor" id="line-155"></span><span class="anchor" id="line-156"></span><p class="line867"><small>Translation of revision 35</small> <span class="anchor" id="line-157"></span><span class="anchor" id="bottom"></span></div>
</div>
<hr>
2023-09-11 07:23
</body>
</html>
